---
title: PublicKeyCredentialRequestOptions.challenge
slug: Web/API/PublicKeyCredentialRequestOptions/challenge
tags:
  - API
  - Property
  - PublicKeyCredentialRequestOptions
  - Reference
  - Web Authentication API
  - WebAuthn
---
<p>{{APIRef("Web Authentication API")}}{{securecontext_header}}</p>

<p>The <strong><code>challenge</code></strong> property of the {{domxref("PublicKeyCredentialRequestOptions")}} dictionary is a {{domxref("BufferSource")}} used as <a href="https://en.wikipedia.org/wiki/Challenge%E2%80%93response_authentication">a cryptographic challenge</a>. This is randomly generated then sent from the relying party's server. This value (among other client data) will be signed by the authenticator's private key and produce {{domxref("AuthenticatorAssertionResponse.signature")}} which should be sent back to the server as part of the response.</p>

<div class="notecard note">
<p><strong>Note:</strong> When the credential is created with a {{domxref("CredentialsContainer.create()","navigator.credentials.create()")}} call, the signature of the challenge is contained within {{domxref("AuthenticatorAttestationResponse.attestationObject")}}.</p>
</div>

<div class="notecard note">
<p><strong>Note:</strong> A challenge will be at least 16 bytes long.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>challenge </em>= <em>publicKeyCredentialRequestOptions</em>.challenge</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("BufferSource")}} which is at least 16 bytes long. Contains a cryptographic challenge emitted from the relying party's server which must be signed by the authenticator's private key and sent back (within the {{domxref("AuthenticatorAssertionResponse.signature","response","",1)}}) to the relying party's server for verification.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var options = {
  challenge: new Uint8Array([/* bytes sent from the server */])
};

navigator.credentials.get({ "publicKey": options })
    .then(function (credentialInfoAssertion) {
    // send assertion response back to the server
    // to proceed with the control of the credential
}).catch(function (err) {
     console.error(err);
});

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#dom-publickeycredentialrequestoptions-challenge','challenge')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredentialRequestOptions.challenge")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("AuthenticatorAssertionResponse.signature")}} which is produced using the challenge and the private key of the authenticator when fetching a credential.</li>
 <li>{{domxref("PublicKeyCredentialCreationOptions.challenge")}}, the analogous option property used when creating a credential.</li>
 <li>{{domxref("AuthenticatorAttestationResponse.attestationObject")}} which contains the signature of the challenge within its <code>attStmt</code> property when creating a credential.</li>
</ul>
